<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- ......................................................................
	Copyright (c) 2003 - 2006 by Burkhardt Renz. 
	EMail: Burkhardt.Renz@mni.fh-giessen.de

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation www.fsf.org.

	This program is distributed in the hope that it will be useful, but without
	any warranty. See the GNU General Publice License for more details.
  .........................................................................
	$Header: e:/mpt/xpp/dd/rcs/dd2doc.xsl 1.13 2006/10/25 14:45:44Z br Exp $
  .........................................................................
	$Log: dd2doc.xsl $
	Revision 1.13  2006/10/25 14:45:44Z  br
	latin modern
	Revision 1.12  2006/10/25 14:40:16Z  br date
	Revision 1.11  2003/07/18 07:10:33Z  br ding
	Revision 1.1  2003/04/17 14:50:18Z  br Initial revision
	......................................................................... -->

<!-- ...................................................................... -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text" encoding="ISO-8859-1" indent="no"/> 
<xsl:strip-space elements="*"/> 

<xsl:variable name="revision" select="substring-before(substring-after('$Revision: 1.13 $', 'Revision:'), ' $')"/> 

<!--  i18n -->
<xsl:variable name="title.text">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Documentation of DTD</xsl:when>
		<xsl:otherwise>Beschreibung der DTD</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="description.title">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Description</xsl:when>
		<xsl:otherwise>Beschreibung</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="reference.title">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Reference</xsl:when>
		<xsl:otherwise>Referenz</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="sect-choice-pe.title">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Parameter entities for elements</xsl:when>
		<xsl:otherwise>Parameter Entities fr Elemente</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="sect-enum-pe.title">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Parameter entities for enumerations</xsl:when>
		<xsl:otherwise>Parameter Entities fr Enumerationen</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="sect-attribute-pe.title">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Parameter entities for attributes</xsl:when>
		<xsl:otherwise>Parameter Entities fr Attribute</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="sect-element.title">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Elements and their attributes</xsl:when>
		<xsl:otherwise>Elemente und ihre Attribute</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="definition.text">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Definition</xsl:when>
		<xsl:otherwise>Definition</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="description.text">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Description</xsl:when>
		<xsl:otherwise>Beschreibung</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="attributes.text">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Attributes</xsl:when>
		<xsl:otherwise>Attribute</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="example.text">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Example</xsl:when>
		<xsl:otherwise>Beispiel</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:variable name="generated.text">
	<xsl:choose>
		<xsl:when test="//dtddoc/@xml:lang='en'">Generated by dd2doc.xsl 
			from</xsl:when>
		<xsl:otherwise>Generiert mit dd2doc.xsl aus</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:template match="/"><xsl:text/>
% ----------------------------------------------------------------------------
<xsl:apply-templates/> 
% ----------------------------------------------------------------------------
</xsl:template>

<xsl:template match="dtddoc"><xsl:text/>
% Documentation of Document Type Definition <xsl:value-of select="@name"/>
% generated by dd2doc.xsl <xsl:value-of select="$revision"/> 
% (c) 2003 by Burkhardt Renz, University of Applied Sciences Giessen-Friedberg.
% ----------------------------------------------------------------------------

\documentclass[pdftex,final,a4paper,11pt]{article}
\usepackage[latin1]{inputenc}
<xsl:if test="not(lang('en'))">\usepackage[ngerman]{babel}</xsl:if>
\usepackage{array}
\newcommand{\PreserveBackslash}[1]{\let\temp=\\#1\let\\=\temp}
\usepackage{graphicx}
\usepackage{color}
\definecolor{Light1}{gray}{.90}
\definecolor{Light2}{gray}{.95}
\newlength{\colorboxwidth}
\setlength{\colorboxwidth}{\textwidth}
\addtolength{\colorboxwidth}{-2\fboxsep}

% font scheme 
\renewcommand{\rmdefault}{lmss}
\renewcommand{\sfdefault}{lmss}
\renewcommand{\ttdefault}{lmtt}
\usepackage[T1]{fontenc}
\usepackage[T1]{url}
 
\usepackage{hyperref}
\hypersetup{colorlinks,
    linkcolor=blue,
    plainpages=false, 
		pdfstartview=FitH,
		pdfpagemode=UseOutlines,
		bookmarksopen=true,
		bookmarksopenlevel=2,
    pdftitle={<xsl:value-of select="$title.text"/><xsl:text> </xsl:text><xsl:value-of select="@name"/>},
    pdfauthor={<xsl:apply-templates select="docinfo/author/name"/> &lt;<xsl:apply-templates select="docinfo/author/email"/>&gt;},
    pdfsubject={<xsl:if test="docinfo/subject"><xsl:apply-templates select="docinfo/subject"/><xsl:text> </xsl:text></xsl:if>Revision <xsl:value-of select="substring-before(substring-after(., 'Revision:'), ' $')"/>},
    pdfkeywords={<xsl:apply-templates select="docinfo/keywords"/>}}

<!-- new environments -->
\newenvironment{ul}
	{\begin{list}{\textbullet}{%
	 \setlength{\partopsep}{0pt}%
	 \setlength{\topsep}{3bp}%
	 \setlength{\itemsep}{0pt}%
	 \setlength{\leftmargin}{24bp}%
	 \setlength{\parsep}{0pt}}}%
	{\end{list}}
\newcounter{olcounter}
\newenvironment{ol}
	{\begin{list}{\arabic{olcounter}.}{%
	 \usecounter{olcounter}%
	 \setlength{\partopsep}{0pt}%
	 \setlength{\topsep}{3bp}%
	 \setlength{\itemsep}{0pt}%
	 \setlength{\leftmargin}{24bp}%
	 \setlength{\parsep}{0pt}}}%
	{\end{list}}
		
\setlength{\parindent}{0pt}
\setlength{\parskip}{6pt}

<xsl:apply-templates select="docinfo"/> 
% document -------------------------------------------------------------------
\begin{document}
\maketitle
\begin{quote}
<xsl:if test="docinfo/note"><xsl:text/>
{\small <xsl:apply-templates select="docinfo/note"/>}\par
</xsl:if>
{\small <xsl:value-of select="$generated.text"/><xsl:text> </xsl:text>
<xsl:value-of select="@name"/>.dd.}
\end{quote}

<xsl:apply-templates select="description"/> 
<xsl:apply-templates select="reference"/> 

% index ----------------------------------------------------------------------
\pagebreak
\setlength{\parskip}{2pt}
\section{Index}
\subsection{<xsl:value-of select="$sect-choice-pe.title"/>}
<xsl:for-each select="/dtddoc/reference/sect-choice-pe/choice-pe">
	<xsl:sort select="@name"/>
	\hyperref[pe:<xsl:value-of select="@name"/>]{\%<xsl:value-of select="@name"/>;}
	\dotfill \pageref{pe:<xsl:value-of select="@name"/>}\par
</xsl:for-each>

\subsection{<xsl:value-of select="$sect-enum-pe.title"/>}
<xsl:for-each select="/dtddoc/reference/sect-enum-pe/enum-pe">
	<xsl:sort select="@name"/>
	\hyperref[pe:<xsl:value-of select="@name"/>]{\%<xsl:value-of select="@name"/>;}
	\dotfill \pageref{pe:<xsl:value-of select="@name"/>}\par
</xsl:for-each>

\subsection{<xsl:value-of select="$sect-attribute-pe.title"/>}
<xsl:for-each select="/dtddoc/reference/sect-attribute-pe/attribute-pe">
	<xsl:sort select="@name"/>
	\hyperref[pe:<xsl:value-of select="@name"/>]{\%<xsl:value-of select="@name"/>;}
	\dotfill \pageref{pe:<xsl:value-of select="@name"/>}\par
</xsl:for-each>

\subsection{<xsl:value-of select="$sect-element.title"/>}
<xsl:for-each select="/dtddoc/reference/sect-element/element">
	<xsl:sort select="@name"/>
	\hyperref[el:<xsl:value-of select="@name"/>]<xsl:text/>{<xsl:value-of select="@name"/>}
	\dotfill \pageref{el:<xsl:value-of select="@name"/>}\par
</xsl:for-each>

\end{document}
% Document end ---------------------------------------------------------------
</xsl:template>

<xsl:template match="docinfo">
% docinfo --------------------------------------------------------------------
\title{\textbf{<xsl:value-of select="$title.text"/><xsl:text> </xsl:text><xsl:value-of select="//dtddoc/@name"/>}<xsl:if test="./subject">\\<xsl:apply-templates select="./subject"/></xsl:if>}
\author{<xsl:apply-templates select="./author/name"/>
<xsl:if test="./author/address">\\<xsl:apply-templates select="./author/address"/></xsl:if>
\\\texttt{<xsl:value-of select="./author/email"/>}}
\date{Revision <xsl:value-of select="substring-before(substring-after(., 'Revision:'), ' $')"/><xsl:text> </xsl:text><xsl:value-of select="./date"/>}
</xsl:template>

<xsl:template match="description">
% description ----------------------------------------------------------------
<xsl:choose>
	<xsl:when test="title">\section{<xsl:value-of select="title"/>}</xsl:when>
	<xsl:otherwise>\section{<xsl:value-of select="$description.title"/>}</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="*[not(self::title)]"/> 
</xsl:template>

<xsl:template match="title">
</xsl:template>

<xsl:template match="reference">
% reference ------------------------------------------------------------------
<xsl:choose>
	<xsl:when test="title">\section{<xsl:value-of select="title"/>}</xsl:when>
	<xsl:otherwise>\section{<xsl:value-of select="$reference.title"/>}</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="*[not(self::title)]"/> 
</xsl:template>

<xsl:template match="sect-choice-pe">
<xsl:choose>
	<xsl:when test="title">\subsection{<xsl:value-of select="title"/>}</xsl:when>
	<xsl:otherwise>\subsection{<xsl:value-of select="$sect-choice-pe.title"/>}</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="*[not(self::title)]"/> 
</xsl:template>

<xsl:template match="sect-enum-pe">
<xsl:choose>
	<xsl:when test="title">\subsection{<xsl:value-of select="title"/>}</xsl:when>
	<xsl:otherwise>\subsection{<xsl:value-of select="$sect-enum-pe.title"/>}</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="*[not(self::title)]"/> 
</xsl:template>

<xsl:template match="sect-attribute-pe">
<xsl:choose>
	<xsl:when test="title">\subsection{<xsl:value-of select="title"/>}</xsl:when>
	<xsl:otherwise>\subsection{<xsl:value-of select="$sect-attribute-pe.title"/>}</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="*[not(self::title)]"/> 
</xsl:template>

<xsl:template match="sect-element">
<xsl:choose>
	<xsl:when test="title">\subsection{<xsl:value-of select="title"/>}</xsl:when>
	<xsl:otherwise>\subsection{<xsl:value-of select="$sect-element.title"/>}</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="*[not(self::title)]"/> 
</xsl:template>

<!-- ...................................................................... -->
<xsl:template match="choice-pe">
\subsubsection{<xsl:value-of select="@name"/>}\label{pe:<xsl:value-of select="@name"/>}
\colorbox{Light1}{%
\parbox{\colorboxwidth}{\hangindent=24bp\hangafter=1\texttt{&lt;!ENTITY \% <xsl:value-of select="@name"/>\\ "<xsl:apply-templates select="*[not(self::desc)]"/>"\textgreater}}}

<xsl:if test="desc">
\medskip
\textbf{<xsl:value-of select="$description.text"/>}

<xsl:apply-templates select="desc"/> 
</xsl:if>
</xsl:template>

<xsl:template match="dtd-esc">
~\\Verbatim reproduced in dtd:\\
\colorbox{Light1}{%
\parbox{\colorboxwidth}{\hangindent=24bp\hangafter=1\texttt{<xsl:value-of select="."/>\textgreater}}}
</xsl:template>

<xsl:template match="pcdata">\#PCDATA </xsl:template>

<xsl:template match="choice-pe/element-ref">
	<xsl:if test="position()!=1"> | </xsl:if>\hyperref[el:<xsl:value-of select="@name"/>]{<xsl:value-of select="@name"/>}</xsl:template>

<xsl:template match="choice-pe-ref">
	<xsl:if test="position()!=1"> | </xsl:if>\hyperref[pe:<xsl:value-of select="@name"/>]{\%<xsl:value-of select="@name"/>;}</xsl:template>


<!-- ...................................................................... -->
<xsl:template match="enum-pe">
\subsubsection{<xsl:value-of select="@name"/>}\label{pe:<xsl:value-of select="@name"/>}
\colorbox{Light1}{%
\parbox{\colorboxwidth}{\hangindent=24bp\hangafter=1\texttt{&lt;!ENTITY \% <xsl:value-of select="@name"/>\\ '( <xsl:apply-templates select="*[not(self::desc)]"/> )'\textgreater}}}

<xsl:if test="desc">
\medskip
\textbf{<xsl:value-of select="$description.text"/>}

<xsl:apply-templates select="desc"/> 
</xsl:if>

\let\PBS=\PreserveBackslash
\medskip
\begin{tabular}{>{\PBS\raggedright}p{60bp}>{\PBS\raggedright}p{274bp}}
<xsl:for-each select="./enum">
<xsl:value-of select="@value"/>&amp;<xsl:value-of select="@desc"/>\\
</xsl:for-each>
\end{tabular}
</xsl:template>

<xsl:template match="enum">
	<xsl:if test="position()!=1"> | </xsl:if><xsl:value-of select="@value"/>
</xsl:template>

<!-- ...................................................................... -->
<xsl:template match="attribute-pe">
\subsubsection{<xsl:value-of select="@name"/>}\label{pe:<xsl:value-of select="@name"/>}
\colorbox{Light1}{%
\parbox{\colorboxwidth}{\hangindent=24bp\hangafter=1\texttt{&lt;!ENTITY \% <xsl:value-of select="@name"/>\\ ' <xsl:apply-templates select="*[not(self::desc)]"/> '\textgreater}}}

<xsl:if test="desc">
\medskip
\textbf{<xsl:value-of select="$description.text"/>}

<xsl:apply-templates select="desc"/> 
</xsl:if>
\let\PBS=\PreserveBackslash
\medskip
\begin{tabular}{>{\PBS\raggedright}p{60bp}>{\PBS\raggedright}p{274bp}}
<xsl:for-each select="./attribute">
<xsl:value-of select="@name"/>&amp;<xsl:value-of select="@desc"/>\\
</xsl:for-each>
\end{tabular}
</xsl:template>

<!-- ...................................................................... -->
<xsl:template match="element">
\subsubsection{<xsl:value-of select="@name"/>}\label{el:<xsl:value-of select="@name"/>}

%\textbf{<xsl:value-of select="$definition.text"/>}
\medskip

\colorbox{Light1}{%
\parbox{\colorboxwidth}{\hangindent=24bp\hangafter=1\texttt{&lt;!ELEMENT <xsl:value-of select="@name"/> <xsl:apply-templates select="empty|any|mixed|sequence|choice"/> \textgreater}}}
<xsl:if test="attlist">
\colorbox{Light2}{%
\parbox{\colorboxwidth}{\hangindent=24bp\hangafter=1\texttt{<xsl:apply-templates select="attlist"/>}~\par}}
</xsl:if>

<xsl:if test="desc">
\medskip
\textbf{<xsl:value-of select="$description.text"/>}

<xsl:apply-templates select="desc"/> 
</xsl:if>

<xsl:if test="attlist/attribute">
\medskip
\textbf{<xsl:value-of select="$attributes.text"/>}

\let\PBS=\PreserveBackslash
\begin{tabular}{>{\PBS\raggedright}p{60bp}>{\PBS\raggedright}p{274bp}}
<xsl:for-each select="./attlist/attribute">
<xsl:value-of select="@name"/>&amp;<xsl:value-of select="@desc"/>\\
</xsl:for-each>
\end{tabular}
</xsl:if>

<xsl:if test="example">

\textbf{<xsl:value-of select="$example.text"/>}
<xsl:apply-templates select="example"/> 
</xsl:if>

</xsl:template>

<xsl:template match="empty"> EMPTY</xsl:template>

<xsl:template match="any"> ANY</xsl:template>

<xsl:template match="mixed">\\ ( <xsl:apply-templates/> )<xsl:if test="element-ref or choice-pe-ref">*</xsl:if>

</xsl:template>

<xsl:template match="mixed/element-ref">
	<xsl:if test="position()!=1"> | </xsl:if>\hyperref[el:<xsl:value-of select="@name"/>]{<xsl:value-of select="@name"/>}</xsl:template>

<xsl:template match="sequence"><xsl:text/>
<xsl:if test="position()!=1 and name(..)='choice'"> | </xsl:if><xsl:text/>
<xsl:if test="name(..)='element'">\\</xsl:if><xsl:text/>
( <xsl:apply-templates/> )<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if> 
</xsl:template>

<xsl:template match="sequence/element-ref">
	<xsl:if test="position()!=1">, </xsl:if>\hyperref[el:<xsl:value-of select="@name"/>]{<xsl:value-of select="@name"/>}<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if></xsl:template>

<xsl:template match="sequence/choice"> <xsl:if test="position()!=1">, </xsl:if>(<xsl:apply-templates/> )<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if> 
</xsl:template>

<xsl:template match="choice">\\(<xsl:apply-templates/>)<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if> 
</xsl:template>

<xsl:template match="choice/element-ref">
	<xsl:if test="position()!=1"> | </xsl:if>\hyperref[el:<xsl:value-of select="@name"/>]{<xsl:value-of select="@name"/>}<xsl:if test="repeat"><xsl:value-of select="@repeat"/></xsl:if></xsl:template>

<xsl:template match="attlist">&lt;!ATTLIST <xsl:value-of select="../@name"/> <xsl:apply-templates/>>
</xsl:template>

<xsl:template match="attribute">
<xsl:if test="position() > 1 or name(..)='attlist'">\\</xsl:if>
<xsl:value-of select="@name"/><xsl:text>	</xsl:text>
<xsl:if test="not(@type='enum')"><xsl:value-of select="@type"/></xsl:if>
<xsl:if test="@enum-pe-ref">\hyperref[pe:<xsl:value-of select="@enum-pe-ref"/>]{\%<xsl:value-of select="@enum-pe-ref"/>;}</xsl:if><xsl:text>	</xsl:text>
<xsl:choose>
	<xsl:when test="@default='req'">\#REQUIRED</xsl:when>
	<xsl:when test="@default='impl'">\#IMPLIED</xsl:when>
	<xsl:when test="@default='fixval' and lang('en')">\#FIXED "<xsl:value-of select="@val"/>"</xsl:when>
	<xsl:when test="@default='fixval' and lang('de')">\#FIXED {\dq}<xsl:value-of select="@val"/>{\dq}</xsl:when>
	<xsl:when test="@default='val' and lang('en')">"<xsl:value-of select="@val"/>"</xsl:when>
	<xsl:when test="@default='val' and lang('de')">{\dq}<xsl:value-of select="@val"/>{\dq}</xsl:when>
</xsl:choose>
</xsl:template>

<xsl:template match="attribute-pe-ref">
<xsl:if test="position() > 1 or name(..)='attlist'">\\</xsl:if>\hyperref[pe:<xsl:value-of select="@name"/>]{\%<xsl:value-of select="@name"/>;}</xsl:template>

<!-- Documentation ........................................................ -->
<xsl:template match="desc">
{<xsl:apply-templates/>\par}
</xsl:template>

<xsl:template match="example">
{<xsl:apply-templates/>\par}
</xsl:template>

<xsl:template match="em">{\em <xsl:apply-templates/>}</xsl:template>

<xsl:template match="q">
<xsl:if test="not(lang('de'))">{"<xsl:apply-templates/>"}</xsl:if>
<xsl:if test="lang('de')">{"`<xsl:apply-templates/>"'}</xsl:if>
</xsl:template>

<xsl:template match="tt">\texttt{<xsl:apply-templates/>}</xsl:template>

<xsl:template match="v">\begin{verbatim}
<xsl:apply-templates/>
\end{verbatim}</xsl:template>

<xsl:template match="nl">{\newline}</xsl:template>
<xsl:template match="address/nl">\\</xsl:template>

<xsl:template match="gt">{\textgreater}</xsl:template>

<xsl:template match="lt">{\textless}</xsl:template>

<xsl:template match="amp">\&amp;</xsl:template>

<xsl:template match="ding">\ding{<xsl:value-of select="."/>}</xsl:template>

<xsl:template match="img">
<xsl:if test="@left">\hspace*{<xsl:value-of select="@left"/>bp}</xsl:if>
<xsl:if test="@hasBox='true'">\fbox{</xsl:if><xsl:text/>
\includegraphics<xsl:if test="@width">[width=<xsl:value-of select="@width"/>bp]</xsl:if><xsl:if test="not(@width)">[width=\linewidth]</xsl:if>
{<xsl:value-of select="@file"/>.<xsl:value-of select="@ext"/>}<xsl:text/>
<xsl:if test="@hasBox='true'">}</xsl:if>
</xsl:template>

<xsl:template match="ul">
\begin{ul}
<xsl:apply-templates select="./li"/>
\end{ul}
</xsl:template>

<xsl:template match="ol">
\begin{ol}
<xsl:apply-templates select="./li"/>
\end{ol}
</xsl:template>

<xsl:template match="li"><xsl:text/>
	\item <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
<!-- ...................................................................... -->
