<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- ......................................................................
	Copyright (c) 2003 by Burkhardt Renz. 
	EMail: Burkhardt.Renz@mni.fh-giessen.de

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation www.fsf.org.

	This program is distributed in the hope that it will be useful, but without
	any warranty. See the GNU General Publice License for more details.
  .........................................................................
	$Header: e:/mpt/xpp/dd/rcs/dd2dtd.xsl 1.8 2003/05/05 13:52:08Z br Exp $
  .........................................................................
	$Log: dd2dtd.xsl $
	Revision 1.8  2003/05/05 13:52:08Z  br
	first complete version
	Revision 1.5  2003/04/26 10:50:52Z  br no comments in dtd
	Revision 1.1  2003/03/01 15:56:22Z  br Initial revision
	......................................................................... -->

<!-- ...................................................................... -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text" encoding="ISO-8859-1" indent="no"/> 
<xsl:strip-space elements="*"/> 

<xsl:variable name="revision" select="substring-before(substring-after('$Revision: 1.8 $', 'Revision:'), ' $')"/> 

<xsl:template match="/"><xsl:text/>
&lt;!-- ................................................................... --><xsl:text/>
<xsl:apply-templates/>
&lt;!-- ................................................................... -->
</xsl:template>

<xsl:template match="dtddoc">
&lt;!-- Document Type Definition <xsl:value-of select="@name"/>
     generated by dd2dtd.xsl<xsl:value-of select="$revision"/> 
		 (c) 2003 by University of Applied Sciences Giessen-Friedberg.
     EMail: Burkhardt.Renz@mni.fh-giessen.de

		 Typical invocation:
		 &lt;!DOCTYPE <xsl:value-of select="@name"/> SYSTEM "<xsl:value-of select="@name"/>.dtd">
     ...................................................................<xsl:text/>
<xsl:apply-templates select="*[not(self::description)]"/> 
</xsl:template>

<xsl:template match="docinfo">
     DTD defined by<xsl:text/>
	<xsl:apply-templates select="author | revision"/>
     ................................................................... -->
</xsl:template>

<xsl:template match="author">
     Author <xsl:apply-templates select="name"/>
		 E-Mail <xsl:apply-templates select="email"/>
</xsl:template>
<xsl:template match="revision">
     Revision <xsl:value-of select="substring-before(substring-after(., 'Revision:'), ' $')"/> 
</xsl:template>

<xsl:template match="sect-choice-pe">
&lt;!-- ................................................................... -->
&lt;!-- parameter entities for choices of elements ........................ -->
<xsl:apply-templates select="choice-pe | dtd-esc"/> 
</xsl:template>

<xsl:template match="sect-enum-pe">
&lt;!-- ................................................................... -->
&lt;!-- parameter entities for enumerated types of attributes ............. -->
<xsl:apply-templates select="enum-pe | dtd-esc"/> 
</xsl:template>

<xsl:template match="sect-attribute-pe">
&lt;!-- ................................................................... -->
&lt;!-- parameter entities for attributes ................................. -->
<xsl:apply-templates select="attribute-pe | dtd-esc"/> 
</xsl:template>

<xsl:template match="sect-element">
&lt;!-- ................................................................... -->
&lt;!-- declaration of elements and their attributes ...................... -->
<xsl:apply-templates select="element | dtd-esc"/> 
</xsl:template>

<!-- ...................................................................... -->
<xsl:template match="choice-pe">
&lt;!ENTITY % <xsl:value-of select="@name"/> " <xsl:apply-templates select="*[not(self::desc)]"/> 
">
</xsl:template>

<xsl:template match="dtd-esc"><xsl:value-of select="."/><xsl:text/>
</xsl:template>

<xsl:template match="pcdata">
	#PCDATA <xsl:text/>
</xsl:template>

<xsl:template match="choice-pe/element-ref">
	<xsl:if test="position()!=1">&#xd;&#x9;|</xsl:if> 
	<xsl:value-of select="@name"/><xsl:text/>
</xsl:template>

<xsl:template match="choice-pe-ref">
	<xsl:if test="position()!=1">&#xd;&#x9;|</xsl:if>%<xsl:value-of select="@name"/>; <xsl:text/>
</xsl:template>

<!-- ...................................................................... -->
<xsl:template match="enum-pe">
&lt;!ENTITY % <xsl:value-of select="@name"/> '(
	<xsl:apply-templates select="*[not(self::desc)]"/> 
)'>
</xsl:template>

<xsl:template match="enum">
	<xsl:if test="position()!=1">&#xd;&#x9;|</xsl:if>
	<xsl:value-of select="@value"/>
</xsl:template>


<!-- ...................................................................... -->
<xsl:template match="attribute-pe">
&lt;!ENTITY % <xsl:value-of select="@name"/> ' <xsl:apply-templates select="*[not(self::desc)]"/> 
'>
</xsl:template>

<!-- match="attribute" see below -->

<!-- ...................................................................... -->
<xsl:template match="element">
&lt;!ELEMENT <xsl:value-of select="@name"/> <xsl:apply-templates select="empty|any|mixed|sequence|choice"/>&gt;
<xsl:apply-templates select="attlist"/> 
</xsl:template>

<xsl:template match="empty"> EMPTY</xsl:template>

<xsl:template match="any"> ANY</xsl:template>

<xsl:template match="mixed"> ( <xsl:apply-templates/>)<xsl:if test="element-ref or choice-pe-ref">*</xsl:if>

</xsl:template>

<!-- pcdata see above -->

<xsl:template match="mixed/element-ref">
	<xsl:if test="position()!=1">&#xd;&#x9;|</xsl:if>
	<xsl:value-of select="@name"/>
</xsl:template>


<!-- choice-pe-ref see above -->

<xsl:template match="sequence"> 
	<xsl:if test="position()!=1 and name(..)='choice'">|</xsl:if> ( 
	<xsl:apply-templates/>)<xsl:text/>
	<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if> 
</xsl:template>

<xsl:template match="sequence/element-ref">
	<xsl:if test="position()!=1">,&#xd;&#x9;</xsl:if>
	<xsl:value-of select="@name"/>
	<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if>
</xsl:template>

<xsl:template match="sequence/choice"> 
	<xsl:if test="position()!=1">,&#xd;&#x9;</xsl:if>(<xsl:apply-templates/>)<xsl:text/>
	<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if> 
</xsl:template>

<xsl:template match="choice"> (&#xd;&#x9;<xsl:apply-templates/>)<xsl:text/>
	<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if> 
</xsl:template>

<xsl:template match="choice/element-ref">
	<xsl:if test="position()!=1">&#xd;&#x9;| </xsl:if>
	<xsl:value-of select="@name"/>
	<xsl:if test="@repeat"><xsl:value-of select="@repeat"/></xsl:if>
</xsl:template>

<!-- choice-pe-ref see above -->

<xsl:template match="attlist">&lt;!ATTLIST <xsl:value-of select="../@name"/>
	<xsl:apply-templates/>&gt;
</xsl:template>

<xsl:template match="attribute">
<xsl:text>&#xD;&#x9;</xsl:text><xsl:value-of select="@name"/><xsl:text>	</xsl:text>
<xsl:if test="not(@type='enum')"><xsl:value-of select="@type"/></xsl:if>
<xsl:if test="@enum-pe-ref">%<xsl:value-of select="@enum-pe-ref"/>;</xsl:if><xsl:text>	</xsl:text>
<xsl:choose>
	<xsl:when test="@default='req'">#REQUIRED</xsl:when>
	<xsl:when test="@default='impl'">#IMPLIED</xsl:when>
	<xsl:when test="@default='fixval'">#FIXED "<xsl:value-of select="@val"/>"</xsl:when>
	<xsl:when test="@default='val'">"<xsl:value-of select="@val"/>"</xsl:when>
</xsl:choose>
</xsl:template>

<xsl:template match="attribute-pe-ref">
	%<xsl:value-of select="@name"/>;</xsl:template>

<!-- ...................................................................... -->
<!--  Documentation (not used) -->

<xsl:template match="title">
&lt;!-- <xsl:apply-templates/> --></xsl:template>

<xsl:template match="desc">
&lt;!-- <xsl:apply-templates/> --></xsl:template>

<xsl:template match="em"><xsl:apply-templates/></xsl:template>
<xsl:template match="tt"><xsl:apply-templates/></xsl:template>
<xsl:template match="nl">&#xd;</xsl:template>
<xsl:template match="gt">&gt;</xsl:template>
<xsl:template match="lt">&lt;</xsl:template>
<xsl:template match="ul"></xsl:template>
<xsl:template match="ol"></xsl:template>
<xsl:template match="li"></xsl:template>
<xsl:template match="img"></xsl:template>

	
</xsl:stylesheet>
<!-- ...................................................................... -->
